;---------------------------------------------------------------------
;   2000/08/21
;
; nasm -f elf testterm.asm
; ld -s -o testterm testterm.o
;---------------------------------------------------------------------

section .text
global _start

%include "readline.inc"

;====================================
; ᥤ롼
;====================================
_start:
                ; üΥ륨 OFF
                ; termios ¸
                call   GET_TERMIOS
                call   SET_TERMIOS
                ;  termios  c_cc ɽ
                call   PRINT_TERMIOS
                call   NewLine

                ; 1 
                mov    eax, MSG_EDIT
                call   OutAsciiZ
                mov    eax, 0x100
                mov    ebx, INBUFFER
                call   READ_LINE

                ; Ƥɽ
                mov    edx, eax
                mov    eax, INBUFFER
                call   OutString
                call   NewLine

                ; termios 
                call   RESTORE_TERMIOS

                ; ɥɽ
                call   NewLine
                mov    eax, MSG_WINSIZE
                call   OutAsciiZ
                call   PRINT_WINSIZE
                call   NewLine

                ; ץཪλ
                call   Exit

;------------------------------------
; ɥɽ
PRINT_WINSIZE:
                pusha
                call   tcgetwinsize
                mov    ebx, wsize
                xor    eax, eax
                mov    ax, [ebx + winsize.ws_col]
                call   PrintLeft
                mov    eax, "x"
                call   OutChar
                xor    eax, eax
                mov    ax, [ebx + winsize.ws_row]
                call   PrintLeft
                call   NewLine
                popa
                ret

;------------------------------------
; ɥ
SET_WINSIZE:
                pusha
                mov    ebx, wsize
                mov    ax, 80
                mov    [ebx + winsize.ws_col], ax
                mov    ax, 25
                mov    [ebx + winsize.ws_row], ax
                call   tcsetwinsize
                popa
                ret

;------------------------------------
; termios ɽ
PRINT_TERMIOS:
                pusha
                mov    eax, MSG_C_CC
                call   OutAsciiZ
                mov    ecx,  new_termios - old_termios
                mov    esi,  old_termios
 .loop1:        mov    al,   [esi]
                call   PrintHex2
                inc    esi
                loop   .loop1
                call   NewLine
                mov    ecx,  new_termios_end - new_termios
                mov    esi,  new_termios
 .loop2:        mov    al,   [esi]
                call   PrintHex2
                inc    esi
                loop   .loop2
                call   NewLine
                popa
                ret

;------------------------------------
; ߤ termios ¸
GET_TERMIOS:
                pusha
                mov    ebx, old_termios
                call   tcgetattr
                mov    ecx,  new_termios - old_termios
                mov    esi,  old_termios
                mov    edi,  new_termios
                rep
                movsb
                popa
                ret

;------------------------------------
;  termios 
; Raw⡼, ECHO ̵, ECHONL ̵
; VTIME=0, VMIN=1 : 1Хɤ߼ޤԵ
SET_TERMIOS:
                pusha
                mov    eax, [new_termios.c_lflag]
                and    eax, ~ICANON & ~ECHO & ~ECHONL & ~ISIG
                mov    [new_termios.c_lflag], eax
                mov    eax, 1
                mov    [new_termios.c_cc + VMIN], al
                mov    eax, 0
                mov    [new_termios.c_cc + VTIME], al
                mov    ebx, new_termios
                call   tcsetattr
                popa
                ret

;------------------------------------
; ¸Ƥ termios 
RESTORE_TERMIOS:
                pusha
                mov    ebx, old_termios
                call   tcsetattr
                popa
                ret

;------------------------------------
;ɥμ
; tcgetwinsize(&ws)
; tcsetwinsize(&ws)
; eax, ebx, ecx, edx : destroyed
tcgetwinsize:
                mov    ecx,  TIOCGWINSZ
                jmp    short IOCTLWINSZ

tcsetwinsize:
                mov    ecx,  TIOCSWINSZ
IOCTLWINSZ:
                mov    edx, wsize
                mov    eax, SYS_ioctl ; (54)
                mov    ebx, 0         ; to stdout
                int    0x80           ; call kernel
                ret

;------------------------------------
; ɸϤ termios μ
; tcgetattr(&termios)
; tcsetattr(&termios)
; eax : destroyed
; ebx : termios buffer adress
; ecx, edx : destroyed
tcgetattr:
                mov    eax, TCGETS
                jmp    short IOCTL

tcsetattr:
                mov    eax, TCSETS

;------------------------------------
; ɸϤ ioctl μ¹
; sys_ioctl(unsigned int fd, unsigned int cmd,
;           unsigned long arg)
; eax : cmd
; ebx : buffer adress
IOCTL:
                mov    ecx, eax       ; set cmd
                mov    edx, ebx       ; set arg
                mov    eax, 54        ; sys_ioctl
                mov    ebx, 0         ; to stdin
                int    0x80           ; call kernel
                ret

MSG_EDIT    db  'Input a line (Del:^D, BS:^H, Back:^B, Forward:^F).', 0x0A, 0
MSG_C_CC    db  'Termios c_cc[] : ', 0x0A, 0
MSG_WINSIZE db  'Window size : ', 0

;------------------------------------
section .bss

INBUFFER        resb 0x100

old_termios     istruc termios
                  .c_iflag    UINT   1       ; input mode flags
                  .c_oflag    UINT   1       ; output mode flags
                  .c_cflag    UINT   1       ; control mode flags
                  .c_lflag    UINT   1       ; local mode flags
                  .c_line     UCHAR  1       ; line discipline
                  .c_cc       UCHAR  NCCS    ; control characters
                iend

new_termios     istruc termios
                  .c_iflag    UINT   1       ; input mode flags
                  .c_oflag    UINT   1       ; output mode flags
                  .c_cflag    UINT   1       ; control mode flags
                  .c_lflag    UINT   1       ; local mode flags
                  .c_line     UCHAR  1       ; line discipline
                  .c_cc       UCHAR  NCCS    ; control characters
                iend
new_termios_end

wsize           istruc winsize
                  .ws_row     USHORT 1
                  .ws_col     USHORT 1
                  .ws_xpixel  USHORT 1
                  .ws_ypixel  USHORT 1
                iend

;------------------------------------
